<?

CModule::IncludeModule("iblock");

$IBLOCK_ID = $VARS["IBLOCK_ID"];

	
$ElementsCount = CIBlockElement::GetList(
	Array(),
	Array(
		"IBLOCK_ID"=>$IBLOCK_ID,
	),
	Array()
);
	
	
//$ElementsCount = 1000;
	
while ($cur_step<$ElementsCount)
{

	$rsElements = CIBlockElement::GetList(
    	Array("ID"=>"ASC"),
    	Array("IBLOCK_ID"=>$IBLOCK_ID),
    	false,
    	Array("nPageSize"=>1,"iNumPage"=>($cur_step+1)),
		Array("ID","IBLOCK_ID","PROPERTY_*")
    );

	while($obElement=$rsElements->GetNextElement()) {

		$added++;

		$arElement = $obElement->GetFields();
		
		$arBaseProp = $obElement->GetProperty($VARS["BASE_PROPERTY_ID"]);
		
		$arOtherProps = Array();
		foreach($VARS["OTHER_PROPERTY_ID"] as $PROPERTY_ID)
			$arOtherProps[$PROPERTY_ID] = $obElement->GetProperty($PROPERTY_ID);
	
	
		if($arBaseProp["PROPERTY_TYPE"]=="L") { // list

			$rsBasePropEnum = CIBlockPropertyEnum::GetList(Array(), Array("IBLOCK_ID"=>$IBLOCK_ID, "PROPERTY_ID"=>$arBaseProp["ID"]));
			$arBasePropEnum = Array();
			while($arEnum=$rsBasePropEnum->Fetch())
				$arBasePropEnum[] = $arEnum;
			
			if($arBaseProp["MULTIPLE"]=="Y" && (!$arBaseProp["~VALUE"] || $VARS["OVERWRITE"]=="Y")) {

				foreach($arOtherProps as $arOtherProp) {
					if($arOtherProp["VALUE_XML_ID"]) {
						$arNewEnumID = Array();
						foreach($arOtherProp["VALUE_ENUM_ID"] as $k=>$OTHER_PROP_VALUE_ENUM_ID) {
							$OTHER_PROP_VALUE_XML_ID = $arOtherProp["VALUE_XML_ID"][$k];
							$ENUM_ID = 0;
							foreach($arBasePropEnum as $arEnum)
								if($arEnum["XML_ID"]==$OTHER_PROP_VALUE_XML_ID)
									$ENUM_ID = $arEnum["ID"];
							if(!$ENUM_ID) { // Adding new enum variant
								if($arOtherPropEnum = CIBlockPropertyEnum::GetByID($OTHER_PROP_VALUE_ENUM_ID)) {
									$obEnum = new CIBlockPropertyEnum;
									$ENUM_ID = $obEnum->Add(Array(
										'PROPERTY_ID'=>$arBaseProp["ID"], 
										'VALUE'=>$arOtherPropEnum["VALUE"],
										'XML_ID'=>$arOtherPropEnum["XML_ID"],
										'SORT'=>$arOtherPropEnum["SORT"],
									));
									GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_LIST_ENUM_ADDED"),"","message");
								}
							}
							if($ENUM_ID)
								$arNewEnumID[] = $ENUM_ID;
						}
						if(CIBlockElement::SetPropertyValueCode($arElement["ID"],$arBaseProp["ID"],$arNewEnumID)) {
							GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_CHANGED"),"","message");
							if((strlen($arBaseProp["~VALUE"])>0) && $VARS["OVERWRITE"]=="Y")
								GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_OVERWRITTEN"),"","message");
						} else {
							GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_UPDATE_ERROR"),"IBLOCK ID: ".$IBLOCK_ID.", ELEMENT ID: ".$arElement["ID"].", PROPERTY_ID: ".$arBaseProp["ID"].", VALUE: ".$arOtherProp["~VALUE"],"message");
						}
						break;
					}
				}

			} elseif($arBaseProp["MULTIPLE"]!="Y" && (!$arBaseProp["~VALUE"] || $VARS["OVERWRITE"]=="Y")) {
				
				foreach($arOtherProps as $arOtherProp) {
					if($arOtherProp["VALUE_XML_ID"]) {
						$ENUM_ID = 0;
						foreach($arBasePropEnum as $arEnum)
							if($arEnum["XML_ID"]==$arOtherProp["VALUE_XML_ID"])
								$ENUM_ID = $arEnum["ID"];
						if(!$ENUM_ID) { // Adding new enum variant
							if($arOtherPropEnum = CIBlockPropertyEnum::GetByID($arOtherProp["VALUE_ENUM_ID"])) {
								$obEnum = new CIBlockPropertyEnum;
								$ENUM_ID = $obEnum->Add(Array(
									'PROPERTY_ID'=>$arBaseProp["ID"], 
									'VALUE'=>$arOtherPropEnum["VALUE"],
									'XML_ID'=>$arOtherPropEnum["XML_ID"],
									'SORT'=>$arOtherPropEnum["SORT"],
								));
								GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_LIST_ENUM_ADDED"),"","message");
							}
						}
						if(CIBlockElement::SetPropertyValueCode($arElement["ID"],$arBaseProp["ID"],$ENUM_ID)) {
							GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_CHANGED"),"","message");
							if((strlen($arBaseProp["~VALUE"])>0) && $VARS["OVERWRITE"]=="Y")
								GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_OVERWRITTEN"),"","message");
						} else {
							GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_UPDATE_ERROR"),"IBLOCK ID: ".$IBLOCK_ID.", ELEMENT ID: ".$arElement["ID"].", PROPERTY_ID: ".$arBaseProp["ID"].", VALUE: ".$arOtherProp["~VALUE"],"message");
						}
						break;
					}
				}
				
			}
			
			
		} else { // all other types
			
			if($arBaseProp["MULTIPLE"]=="Y" && (!$arBaseProp["~VALUE"] || $VARS["OVERWRITE"]=="Y")) {

				foreach($arOtherProps as $arOtherProp) {
					if($arOtherProp["~VALUE"]) {
						if(CIBlockElement::SetPropertyValueCode($arElement["ID"],$arBaseProp["ID"],$arOtherProp["~VALUE"])) {
							GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_CHANGED"),"","message");
							if($arBaseProp["~VALUE"] && $VARS["OVERWRITE"]=="Y")
								GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_OVERWRITTEN"),"","message");
						} else {
							GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_UPDATE_ERROR"),"IBLOCK ID: ".$IBLOCK_ID.", ELEMENT ID: ".$arElement["ID"].", PROPERTY_ID: ".$arBaseProp["ID"].", VALUE: ".print_r($arOtherProp["~VALUE"],true),"message");
						}
						break;
					}
				}

			} elseif($arBaseProp["MULTIPLE"]!="Y" && ((strlen($arBaseProp["~VALUE"])<=0) || $VARS["OVERWRITE"]=="Y")) {
				
				foreach($arOtherProps as $arOtherProp) {
					if(strlen($arOtherProp["~VALUE"])>0) {
						if(CIBlockElement::SetPropertyValueCode($arElement["ID"],$arBaseProp["ID"],$arOtherProp["~VALUE"])) {
							GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_CHANGED"),"","message");
							if((strlen($arBaseProp["~VALUE"])>0) && $VARS["OVERWRITE"]=="Y")
								GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_OVERWRITTEN"),"","message");
						} else {
							GUniWizardTools::AddErrorToLog(GetMessage("WIZ_PROP_JOIN_PROP_UPDATE_ERROR"),"IBLOCK ID: ".$IBLOCK_ID.", ELEMENT ID: ".$arElement["ID"].", PROPERTY_ID: ".$arBaseProp["ID"].", VALUE: ".$arOtherProp["~VALUE"],"message");
						}
						break;
					}
				}
				
			}
			
			
		}
	

		//GUniWizardTools::AddErrorToLog("\$arBaseProp",print_r($arBaseProp,true),"message");		
		//GUniWizardTools::AddErrorToLog("\$arOtherProps",print_r($arOtherProps,true),"message");		

	}


	// Go to next step when time exceed

    $cur_step++;
    
    $cur_time = time();
    
    if ($cur_time >= $finish_time)
    {
    	$bFinish = false;
    	break;
    }						

}

?>